## golang-github-smallstep-certificates 0.15.15

=== Makefile ===
PKG?=github.com/smallstep/certificates/cmd/step-ca
BINNAME?=step-ca
CLOUDKMS_BINNAME?=step-cloudkms-init
CLOUDKMS_PKG?=github.com/smallstep/certificates/cmd/step-cloudkms-init
AWSKMS_BINNAME?=step-awskms-init
AWSKMS_PKG?=github.com/smallstep/certificates/cmd/step-awskms-init
YUBIKEY_BINNAME?=step-yubikey-init
YUBIKEY_PKG?=github.com/smallstep/certificates/cmd/step-yubikey-init
PKCS11_BINNAME?=step-pkcs11-init
PKCS11_PKG?=github.com/smallstep/certificates/cmd/step-pkcs11-init

# Set V to 1 for verbose output from the Makefile
Q=$(if $V,,@)
PREFIX?=
SRC=$(shell find . -type f -name '*.go' -not -path "./vendor/*")
GOOS_OVERRIDE ?=
OUTPUT_ROOT=output/

all: lint test build

ci: testcgo build

.PHONY: all ci

#########################################
# Bootstrapping
#########################################

bootstra%:
	# Using a released version of golangci-lint to take into account custom replacements in their go.mod
	$Q curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(go env GOPATH)/bin v1.39.0

.PHONY: bootstra%

#################################################
# Determine the type of `push` and `version`
#################################################

# If TRAVIS_TAG is set then we know this ref has been tagged.
ifdef TRAVIS_TAG
VERSION ?= $(TRAVIS_TAG)
NOT_RC  := $(shell echo $(VERSION) | grep -v -e -rc)
	ifeq ($(NOT_RC),)
PUSHTYPE := release-candidate
	else
PUSHTYPE := release
	endif
# GITHUB Actions
else ifdef GITHUB_REF
VERSION ?= $(shell echo $(GITHUB_REF) | sed 's/^refs\/tags\///')
NOT_RC  := $(shell echo $(VERSION) | grep -v -e -rc)
	ifeq ($(NOT_RC),)
PUSHTYPE := release-candidate
	else
PUSHTYPE := release
	endif
else
VERSION ?= $(shell [ -d .git ] && git describe --tags --always --dirty="-dev")
# If we are not in an active git dir then try reading the version from .VERSION.
# .VERSION contains a slug populated by `git archive`.
VERSION := $(or $(VERSION),$(shell ./.version.sh .VERSION))
	ifeq ($(TRAVIS_BRANCH),master)
PUSHTYPE := master
	else
PUSHTYPE := branch
	endif
endif

VERSION := $(shell echo $(VERSION) | sed 's/^v//')
DEB_VERSION := $(shell echo $(VERSION) | sed 's/-/~/g')

ifdef V
$(info    TRAVIS_TAG is $(TRAVIS_TAG))
$(info    GITHUB_REF is $(GITHUB_REF))
$(info    VERSION is $(VERSION))
$(info    DEB_VERSION is $(DEB_VERSION))
$(info    PUSHTYPE is $(PUSHTYPE))
endif

include make/docker.mk

#########################################
# Build
#########################################

DATE    := $(shell date -u '+%Y-%m-%d %H:%M UTC')
LDFLAGS := -ldflags='-w -X "main.Version=$(VERSION)" -X "main.BuildTime=$(DATE)"'
GOFLAGS := CGO_ENABLED=0

download:
	$Q go mod download

build: $(PREFIX)bin/$(BINNAME) $(PREFIX)bin/$(CLOUDKMS_BINNAME) $(PREFIX)bin/$(AWSKMS_BINNAME) $(PREFIX)bin/$(YUBIKEY_BINNAME) $(PREFIX)bin/$(PKCS11_BINNAME)
	@echo "Build Complete!"

$(PREFIX)bin/$(BINNAME): download $(call rwildcard,*.go)
	$Q mkdir -p $(@D)
	$Q $(GOOS_OVERRIDE) $(GOFLAGS) go build -v -o $(PREFIX)bin/$(BINNAME) $(LDFLAGS) $(PKG)

$(PREFIX)bin/$(CLOUDKMS_BINNAME): download $(call rwildcard,*.go)
	$Q mkdir -p $(@D)
	$Q $(GOOS_OVERRIDE) $(GOFLAGS) go build -v -o $(PREFIX)bin/$(CLOUDKMS_BINNAME) $(LDFLAGS) $(CLOUDKMS_PKG)

$(PREFIX)bin/$(AWSKMS_BINNAME): download $(call rwildcard,*.go)
	$Q mkdir -p $(@D)
	$Q $(GOOS_OVERRIDE) $(GOFLAGS) go build -v -o $(PREFIX)bin/$(AWSKMS_BINNAME) $(LDFLAGS) $(AWSKMS_PKG)

$(PREFIX)bin/$(YUBIKEY_BINNAME): download $(call rwildcard,*.go)
	$Q mkdir -p $(@D)
	$Q $(GOOS_OVERRIDE) $(GOFLAGS) go build -v -o $(PREFIX)bin/$(YUBIKEY_BINNAME) $(LDFLAGS) $(YUBIKEY_PKG)

$(PREFIX)bin/$(PKCS11_BINNAME): download $(call rwildcard,*.go)
	$Q mkdir -p $(@D)
	$Q $(GOOS_OVERRIDE) $(GOFLAGS) go build -v -o $(PREFIX)bin/$(PKCS11_BINNAME) $(LDFLAGS) $(PKCS11_PKG)

# Target to force a build of step-ca without running tests
simple: build

.PHONY: download build simple

#########################################
# Go generate
#########################################

generate:
	$Q go generate ./...

.PHONY: generate

#########################################
# Test
#########################################
test:
	$Q $(GOFLAGS) go test -short -coverprofile=coverage.out ./...

testcgo:
	$Q go test -short -coverprofile=coverage.out ./...

.PHONY: test testcgo

integrate: integration

integration: bin/$(BINNAME)
	$Q $(GOFLAGS) go test -tags=integration ./integration/...

.PHONY: integrate integration

#########################################
# Linting
#########################################

fmt:
	$Q gofmt -l -w $(SRC)

lint:
	$Q $(GOFLAGS) LOG_LEVEL=error golangci-lint run --timeout=30m

lintcgo:
	$Q LOG_LEVEL=error golangci-lint run --timeout=30m

.PHONY: fmt lint lintcgo

#########################################
# Install
#########################################

INSTALL_PREFIX?=/usr/

install: $(PREFIX)bin/$(BINNAME) $(PREFIX)bin/$(CLOUDKMS_BINNAME) $(PREFIX)bin/$(AWSKMS_BINNAME)
	$Q install -D $(PREFIX)bin/$(BINNAME) $(DESTDIR)$(INSTALL_PREFIX)bin/$(BINNAME)
	$Q install -D $(PREFIX)bin/$(CLOUDKMS_BINNAME) $(DESTDIR)$(INSTALL_PREFIX)bin/$(CLOUDKMS_BINNAME)
	$Q install -D $(PREFIX)bin/$(AWSKMS_BINNAME) $(DESTDIR)$(INSTALL_PREFIX)bin/$(AWSKMS_BINNAME)

uninstall:
	$Q rm -f $(DESTDIR)$(INSTALL_PREFIX)/bin/$(BINNAME)
	$Q rm -f $(DESTDIR)$(INSTALL_PREFIX)/bin/$(CLOUDKMS_BINNAME)
	$Q rm -f $(DESTDIR)$(INSTALL_PREFIX)/bin/$(AWSKMS_BINNAME)

.PHONY: install uninstall

#########################################
# Clean
#########################################

clean:
ifneq ($(BINNAME),"")
	$Q rm -f bin/$(BINNAME)
endif
ifneq ($(CLOUDKMS_BINNAME),"")
	$Q rm -f bin/$(CLOUDKMS_BINNAME)
endif
ifneq ($(AWSKMS_BINNAME),"")
	$Q rm -f bin/$(AWSKMS_BINNAME)
endif
ifneq ($(YUBIKEY_BINNAME),"")
	$Q rm -f bin/$(YUBIKEY_BINNAME)
endif
ifneq ($(PKCS11_BINNAME),"")
	$Q rm -f bin/$(PKCS11_BINNAME)
endif

.PHONY: clean

#########################################
# Dev
#########################################

run:
	$Q go run cmd/step-ca/main.go $(shell step path)/config/ca.json

.PHONY: run

#########################################
# Debian
#########################################

changelog:
	$Q echo "step-ca ($(DEB_VERSION)) unstable; urgency=medium" > debian/changelog
	$Q echo >> debian/changelog
	$Q echo "  * See https://github.com/smallstep/certificates/releases" >> debian/changelog
	$Q echo >> debian/changelog
	$Q echo " -- Smallstep Labs, Inc. <techadmin@smallstep.com>  $(shell date -uR)" >> debian/changelog

debian: changelog
	$Q mkdir -p $(RELEASE); \
	OUTPUT=../step-ca*.deb; \
	rm $$OUTPUT; \
	dpkg-buildpackage -b -rfakeroot -us -uc && cp $$OUTPUT $(RELEASE)/

distclean: clean

.PHONY: changelog debian distclean

#################################################
# Build statically compiled step binary for various operating systems
#################################################

BINARY_OUTPUT=$(OUTPUT_ROOT)binary/
RELEASE=./.releases

define BUNDLE_MAKE
	# $(1) -- Go Operating System (e.g. linux, darwin, windows, etc.)
	# $(2) -- Go Architecture (e.g. amd64, arm, arm64, etc.)
	# $(3) -- Go ARM architectural family (e.g. 7, 8, etc.)
	# $(4) -- Parent directory for executables generated by 'make'.
	$(q) GOOS_OVERRIDE='GOOS=$(1) GOARCH=$(2) GOARM=$(3)' PREFIX=$(4) make $(4)bin/$(BINNAME) $(4)bin/$(CLOUDKMS_BINNAME) $(4)bin/$(AWSKMS_BINNAME)
endef

binary-linux:
	$(call BUNDLE_MAKE,linux,amd64,,$(BINARY_OUTPUT)linux/)

binary-linux-arm64:
	$(call BUNDLE_MAKE,linux,arm64,,$(BINARY_OUTPUT)linux.arm64/)

binary-linux-armv7:
	$(call BUNDLE_MAKE,linux,arm,7,$(BINARY_OUTPUT)linux.armv7/)

binary-darwin:
	$(call BUNDLE_MAKE,darwin,amd64,,$(BINARY_OUTPUT)darwin/)

.PHONY: binary-linux binary-linux-arm64 binary-linux-armv7 binary-darwin

#################################################
# Targets for creating step artifacts
#################################################

docker-artifacts: docker-$(PUSHTYPE)

.PHONY: docker-artifacts

=== examples/docker/Makefile ===
all: binaries build up

binaries:
	CGO_ENABLED=0 GOOS=linux go build -o ca/step-ca github.com/smallstep/certificates/cmd/step-ca
	CGO_ENABLED=0 GOOS=linux go build -o renewer/step github.com/smallstep/cli/cmd/step

build: build-nginx build-ca build-renewer
build-nginx:
	docker build -t nginx-test:latest nginx
build-ca:
	docker build -t step-ca-test:latest ca
build-renewer:
	docker build -t step-renewer-test:latest renewer

up:
	docker-compose up

down:
	docker-compose down

inspect:
	step certificate inspect https://localhost:4443 --insecure

.PHONY: all binaries up down inspect
.PHONY: build build-nginx build-ca build-renewer

=== debian/changelog ===
golang-github-smallstep-certificates (0.15.15-4) unstable; urgency=medium

  * Team upload.
  * Skip another test failing on 32 bit

 -- Nilesh Patra <nilesh@debian.org>  Sat, 20 Aug 2022 14:57:51 +0530

golang-github-smallstep-certificates (0.15.15-3) unstable; urgency=medium

  * Team upload.
  * Skip TestParse which has problems with
    golang 1.19 (skipped upstream as well w/ build tags)
    (Closes: #1010392)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 20 Aug 2022 07:37:48 +0000

golang-github-smallstep-certificates (0.15.15-2) unstable; urgency=medium

  * Team Upload.
  * Move to unstable post release
  * Re-Add Built-Using
  * Add patch to fix build (Closes: #1002969)
  * d/rules: Ignore challenge_test

 -- Nilesh Patra <nilesh@debian.org>  Wed, 16 Feb 2022 03:36:48 +0530

golang-github-smallstep-certificates (0.15.15-1) experimental; urgency=medium

  * Initial release (Closes: #990946)

 -- Peymaneh Nejad <p.nejad@posteo.de>  Tue, 10 Aug 2021 17:29:35 +0200

=== debian/control ===
Source: golang-github-smallstep-certificates
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Peymaneh Nejad <p.nejad@posteo.de>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-masterminds-sprig-dev,
               golang-github-aws-aws-sdk-go-dev,
               golang-github-go-chi-chi-dev,
               golang-github-go-kit-kit-dev,
               golang-github-pkg-errors-dev,
               golang-github-urfave-cli-dev,
               golang-github-stretchr-testify-dev <!nocheck>,
               golang-github-sirupsen-logrus-dev,
               golang-github-smallstep-assert-dev <!nocheck>,
               golang-github-smallstep-nosql-dev,
               golang-github-thalesignite-crypto11-dev,
               golang-github-newrelic-go-agent-dev,
               golang-github-go-piv-piv-go-dev,
               golang-github-google-uuid-dev,
               golang-github-rs-xid-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-gopkg-square-go-jose.v2-dev,
               golang-step-cli-utils-dev,
               golang-step-crypto-dev,
               libpcsclite-dev,
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-smallstep-certificates
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-smallstep-certificates.git
Homepage: https://github.com/smallstep/certificates
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/smallstep/certificates

Package: step-ca
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: private Certificate Authority
 step-ca is and online certificate authority for secure, automated certificate
 management.
 .
 You can use it to:
  - Issue X.509 certificate for your internal infrastructure
    - HTTPS certificate that work in browsers
    - TLS certificates for virtual machines, containers, APIs, mobile clients,
      database connections, printers, Wi-Fi networks, toaster ovens...
    - Client certificates to enable mutual TLS (mTLS) in your infrastrucure.
  - Issue SSH certificates
    - For people, in exchange for single sign-on ID tokens
    - For hosts, in exchange for cloud instance identity documents
  - Easily automate certificate management:
    - It's an ACME v2 server
    - It has a JSON API
 .
 Documentation: https://smallstep.com/docs/step-ca/getting-started

Package: golang-github-smallstep-certificates-dev
Architecture: all
Depends: golang-github-masterminds-sprig-dev,
         golang-github-aws-aws-sdk-go-dev,
         golang-github-go-chi-chi-dev,
         golang-github-go-kit-kit-dev,
         golang-github-pkg-errors-dev,
         golang-github-urfave-cli-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-smallstep-nosql-dev,
         golang-github-thalesignite-crypto11-dev,
         golang-github-newrelic-go-agent-dev,
         golang-github-go-piv-piv-go-dev,
         golang-github-google-uuid-dev,
         golang-github-rs-xid-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-gopkg-square-go-jose.v2-dev,
         golang-step-cli-utils-dev,
         golang-step-crypto-dev,
         libpcsclite-dev,
         ${misc:Depends}
Description: go libraries for private certificate authority
 step-ca is and online certificate authority for secure, automated certificate
 management.
 .
 This package provides multiple go modules used by step-ca (scep, acme, db to
 name a few) as well as example implementations of clients and servers.

=== debian/rules ===
#!/usr/bin/make -f

# Exclude cas/cloudcas, kms/cloudkms and cmd/step-cloudkms-init until golang-google-cloud
# in repos has been updated to v0.83.0
export DH_GOLANG_EXCLUDES := cas/cloudcas cmd/step-cloudkms-init kms/cloudkms examples

include /usr/share/dpkg/pkg-info.mk
VERSION = $(shell echo $(DEB_VERSION) | cut -d- -f1)
LDFLAGS := -ldflags '-w -X "main.Version=$(VERSION)"'

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

execute_before_dh_auto_configure:
	rm -f acme/challenge_test.go acme/db/nosql/challenge_test.go

override_dh_auto_build:
	dh_auto_build -- $(LDFLAGS)

## golang-github-smallstep-certificates 0.19.0

=== Makefile ===
--- 
+++ 
@@ -15,6 +15,7 @@
 SRC=$(shell find . -type f -name '*.go' -not -path "./vendor/*")
 GOOS_OVERRIDE ?=
 OUTPUT_ROOT=output/
+RELEASE=./.releases
 
 all: lint test build
 
@@ -28,7 +29,7 @@
 
 bootstra%:
 	# Using a released version of golangci-lint to take into account custom replacements in their go.mod
-	$Q curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(go env GOPATH)/bin v1.39.0
+	$Q curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(shell go env GOPATH)/bin v1.42.0
 
 .PHONY: bootstra%
 
@@ -67,7 +68,7 @@
 endif
 
 VERSION := $(shell echo $(VERSION) | sed 's/^v//')
-DEB_VERSION := $(shell echo $(VERSION) | sed 's/-/~/g')
+DEB_VERSION := $(shell echo $(VERSION) | sed 's/-/./g')
 
 ifdef V
 $(info    TRAVIS_TAG is $(TRAVIS_TAG))
@@ -153,7 +154,7 @@
 	$Q gofmt -l -w $(SRC)
 
 lint:
-	$Q $(GOFLAGS) LOG_LEVEL=error golangci-lint run --timeout=30m
+	$Q golangci-lint run --timeout=30m
 
 lintcgo:
 	$Q LOG_LEVEL=error golangci-lint run --timeout=30m
@@ -232,35 +233,6 @@
 .PHONY: changelog debian distclean
 
 #################################################
-# Build statically compiled step binary for various operating systems
-#################################################
-
-BINARY_OUTPUT=$(OUTPUT_ROOT)binary/
-RELEASE=./.releases
-
-define BUNDLE_MAKE
-	# $(1) -- Go Operating System (e.g. linux, darwin, windows, etc.)
-	# $(2) -- Go Architecture (e.g. amd64, arm, arm64, etc.)
-	# $(3) -- Go ARM architectural family (e.g. 7, 8, etc.)
-	# $(4) -- Parent directory for executables generated by 'make'.
-	$(q) GOOS_OVERRIDE='GOOS=$(1) GOARCH=$(2) GOARM=$(3)' PREFIX=$(4) make $(4)bin/$(BINNAME) $(4)bin/$(CLOUDKMS_BINNAME) $(4)bin/$(AWSKMS_BINNAME)
-endef
-
-binary-linux:
-	$(call BUNDLE_MAKE,linux,amd64,,$(BINARY_OUTPUT)linux/)
-
-binary-linux-arm64:
-	$(call BUNDLE_MAKE,linux,arm64,,$(BINARY_OUTPUT)linux.arm64/)
-
-binary-linux-armv7:
-	$(call BUNDLE_MAKE,linux,arm,7,$(BINARY_OUTPUT)linux.armv7/)
-
-binary-darwin:
-	$(call BUNDLE_MAKE,darwin,amd64,,$(BINARY_OUTPUT)darwin/)
-
-.PHONY: binary-linux binary-linux-arm64 binary-linux-armv7 binary-darwin
-
-#################################################
 # Targets for creating step artifacts
 #################################################

=== examples/docker/Makefile ===
--- 
+++ 
@@ -2,7 +2,6 @@
 
 binaries:
 	CGO_ENABLED=0 GOOS=linux go build -o ca/step-ca github.com/smallstep/certificates/cmd/step-ca
-	CGO_ENABLED=0 GOOS=linux go build -o renewer/step github.com/smallstep/cli/cmd/step
 
 build: build-nginx build-ca build-renewer
 build-nginx:

=== debian/changelog ===
golang-github-smallstep-certificates (0.19.0-1) unstable; urgency=medium

  * Updating maintainer info
  * Updating Standards-Version
  * New upstream version 0.19.0
  * Drop binary package
  * Drop obsolete patch
  * d/rules: exclude unneeded libraries
  * d/rules: be verbose
  * d/control: Update dependencies
  * Disable disfunctional tests
  * Please lintian

 -- Peymaneh <peymaneh@posteo.net>  Mon, 28 Nov 2022 00:52:26 +0100

=== debian/control ===
Source: golang-github-smallstep-certificates
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Peymaneh <peymaneh@posteo.net>
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-masterminds-sprig-dev,
               golang-github-aws-aws-sdk-go-dev,
               golang-github-go-chi-chi-dev,
               golang-github-go-kit-kit-dev,
               golang-github-pkg-errors-dev,
               golang-github-urfave-cli-dev,
               golang-github-stretchr-testify-dev <!nocheck>,
               golang-github-sirupsen-logrus-dev,
               golang-github-smallstep-assert-dev <!nocheck>,
               golang-github-smallstep-nosql-dev,
               golang-github-thalesignite-crypto11-dev,
               golang-github-micromdm-scep-dev,
               golang-github-newrelic-go-agent-dev,
               golang-github-go-piv-piv-go-dev,
               golang-github-google-uuid-dev,
               golang-github-rs-xid-dev,
               golang-github-fullsailor-pkcs7-dev,
               golang-github-slackhq-nebula-dev (>= 1.6.1~),
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-gopkg-square-go-jose.v2-dev,
               golang-step-cli-utils-dev (>= 0.7.5~),
               golang-step-crypto-dev (>= 0.17.3~),
               golang-step-linkedca-dev,
               libpcsclite-dev,
Standards-Version: 4.6.1.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-smallstep-certificates
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-smallstep-certificates.git
Homepage: https://github.com/smallstep/certificates
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/smallstep/certificates

Package: golang-github-smallstep-certificates-dev
Architecture: all
Depends: golang-github-masterminds-sprig-dev,
         golang-github-aws-aws-sdk-go-dev,
         golang-github-go-chi-chi-dev,
         golang-github-go-kit-kit-dev,
         golang-github-pkg-errors-dev,
         golang-github-urfave-cli-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-smallstep-nosql-dev,
         golang-github-thalesignite-crypto11-dev,
         golang-github-micromdm-scep-dev,
         golang-github-newrelic-go-agent-dev,
         golang-github-go-piv-piv-go-dev,
         golang-github-google-uuid-dev,
         golang-github-rs-xid-dev,
         golang-github-fullsailor-pkcs7-dev,
         golang-github-slackhq-nebula-dev (>= 1.6.1~),
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-gopkg-square-go-jose.v2-dev,
         golang-step-cli-utils-dev (>= 0.7.5~),
         golang-step-crypto-dev (>= 0.17.3~),
         golang-step-linkedca-dev,
         libpcsclite-dev,
         ${misc:Depends}
Description: go libraries for private certificate authority
 step-ca is and online certificate authority for secure, automated certificate
 management.
 .
 This package provides multiple go modules used by step-ca (scep, acme, db to
 name a few) as well as example implementations of clients and servers.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE := 1
# Exclude cas/cloudcas, kms/cloudkms and cmd/step-cloudkms-init until golang-google-cloud
# in repos has been updated to v0.83.0
export DH_GOLANG_EXCLUDES := cmd cas/cloudcas kms/cloudkms kms/azurekms cas/vaultcas examples

#include /usr/share/dpkg/pkg-info.mk
#VERSION = $(shell echo $(DEB_VERSION) | cut -d- -f1)
#LDFLAGS := -ldflags '-w -X "main.Version=$(VERSION)"'

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

execute_before_dh_auto_configure:
	rm -f acme/challenge_test.go acme/db/nosql/challenge_test.go

#override_dh_auto_build:
	#dh_auto_build -- $(LDFLAGS)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%golang-github-smallstep-certificates-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
  https://github.com/smallstep/certificates/tags .*/v?(\d\S*)\.tar\.gz debian

## golang-github-smallstep-certificates 0.20.0

=== Makefile ===
--- 
+++ 
@@ -151,7 +151,7 @@
 #########################################
 
 fmt:
-	$Q gofmt -l -w $(SRC)
+	$Q gofmt -l -s -w $(SRC)
 
 lint:
 	$Q golangci-lint run --timeout=30m

=== debian/changelog ===
golang-github-smallstep-certificates (0.20.0-5) unstable; urgency=medium

  * Team upload
  * Tighten dependency on nebula, fix test. Closes: #1103256.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 15 Apr 2025 19:48:11 +0200

golang-github-smallstep-certificates (0.20.0-4) unstable; urgency=medium

  * Team upload
  * patch: upstream fix for flaky test

 -- Jérémy Lal <kapouer@melix.org>  Tue, 15 Apr 2025 19:47:48 +0200

golang-github-smallstep-certificates (0.20.0-3) unstable; urgency=medium

  * Team upload
  * Fix dependency on smallstep-crypto-dev. Closes: #1102443.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 09 Apr 2025 10:36:26 +0200

golang-github-smallstep-certificates (0.20.0-2) unstable; urgency=medium

  * Team upload
  * Switch to golang-github-smallstep-crypto.
    Bump golang-step-cli-utils to 0.7.5+ds-3 to ensure it is
    using golang-github-smallstep-crypto as well.
  * patch: compatibility with smallstep-crypto. Fix tests.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 08 Apr 2025 12:58:29 +0200

golang-github-smallstep-certificates (0.20.0-1) unstable; urgency=medium

  * Team upload
  * New upstream version 0.20.0.
    This version actually passes its own testsuite.
  * Drop applied patch,
    upstream expects CI env var to be true for testsuite.
  * patch: use smallstep-scep for microscep. Closes: #1101848.

 -- Jérémy Lal <kapouer@melix.org>  Mon, 07 Apr 2025 20:20:31 +0200

=== debian/control ===
--- 
+++ 
@@ -24,12 +24,12 @@
                golang-github-google-uuid-dev,
                golang-github-rs-xid-dev,
                golang-github-fullsailor-pkcs7-dev,
-               golang-github-slackhq-nebula-dev (>= 1.6.1~),
+               golang-github-slackhq-nebula-dev (>= 1.9.3~),
                golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
                golang-gopkg-square-go-jose.v2-dev,
-               golang-step-cli-utils-dev (>= 0.7.5~),
-               golang-step-crypto-dev (>= 0.17.3~),
+               golang-step-cli-utils-dev (>= 0.7.5-3),
+               golang-github-smallstep-crypto-dev,
                golang-step-linkedca-dev,
                libpcsclite-dev,
 Standards-Version: 4.6.1.0
@@ -56,12 +56,12 @@
          golang-github-google-uuid-dev,
          golang-github-rs-xid-dev,
          golang-github-fullsailor-pkcs7-dev,
-         golang-github-slackhq-nebula-dev (>= 1.6.1~),
+         golang-github-slackhq-nebula-dev (>= 1.9.3~),
          golang-golang-x-crypto-dev,
          golang-golang-x-net-dev,
          golang-gopkg-square-go-jose.v2-dev,
-         golang-step-cli-utils-dev (>= 0.7.5~),
-         golang-step-crypto-dev (>= 0.17.3~),
+         golang-step-cli-utils-dev (>= 0.7.5-3),
+         golang-github-smallstep-crypto-dev,
          golang-step-linkedca-dev,
          libpcsclite-dev,
          ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # Exclude cas/cloudcas, kms/cloudkms and cmd/step-cloudkms-init until golang-google-cloud
 # in repos has been updated to v0.83.0
 export DH_GOLANG_EXCLUDES := cmd cas/cloudcas kms/cloudkms kms/azurekms cas/vaultcas examples
-
+export CI := true
 #include /usr/share/dpkg/pkg-info.mk
 #VERSION = $(shell echo $(DEB_VERSION) | cut -d- -f1)
 #LDFLAGS := -ldflags '-w -X "main.Version=$(VERSION)"'

## golang-github-smallstep-certificates 0.28.4

=== Makefile ===
PKG?=github.com/smallstep/certificates/cmd/step-ca
BINNAME?=step-ca

# Set V to 1 for verbose output from the Makefile
Q=$(if $V,,@)
PREFIX?=
SRC=$(shell find . -type f -name '*.go' -not -path "./vendor/*")
GOOS_OVERRIDE ?=

all: lint test build

ci: testcgo build

.PHONY: all ci

#########################################
# Bootstrapping
#########################################

bootstra%:
	$Q curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $$(go env GOPATH)/bin latest
	$Q go install golang.org/x/vuln/cmd/govulncheck@latest
	$Q go install gotest.tools/gotestsum@latest
	$Q go install github.com/goreleaser/goreleaser@latest
	$Q go install github.com/sigstore/cosign/v2/cmd/cosign@latest

.PHONY: bootstra%

#################################################
# Determine the type of `push` and `version`
#################################################

# GITHUB Actions
ifdef GITHUB_REF
VERSION ?= $(shell echo $(GITHUB_REF) | sed 's/^refs\/tags\///')
NOT_RC  := $(shell echo $(VERSION) | grep -v -e -rc)
	ifeq ($(NOT_RC),)
PUSHTYPE := release-candidate
	else
PUSHTYPE := release
	endif
else
VERSION ?= $(shell [ -d .git ] && git describe --tags --always --dirty="-dev")
# If we are not in an active git dir then try reading the version from .VERSION.
# .VERSION contains a slug populated by `git archive`.
VERSION := $(or $(VERSION),$(shell ./.version.sh .VERSION))
PUSHTYPE := branch
endif

VERSION := $(shell echo $(VERSION) | sed 's/^v//')

ifdef V
$(info    GITHUB_REF is $(GITHUB_REF))
$(info    VERSION is $(VERSION))
$(info    PUSHTYPE is $(PUSHTYPE))
endif

#########################################
# Build
#########################################

DATE    := $(shell date -u '+%Y-%m-%d %H:%M UTC')
LDFLAGS := -ldflags='-w -X "main.Version=$(VERSION)" -X "main.BuildTime=$(DATE)"'

# Always explicitly enable or disable cgo,
# so that go doesn't silently fall back on
# non-cgo when gcc is not found.
ifeq (,$(findstring CGO_ENABLED,$(GO_ENVS)))
	ifneq ($(origin GOFLAGS),undefined)
		# This section is for backward compatibility with 
		# 
		# $ make build GOFLAGS=""
		#
		# which is how we recommended building step-ca with cgo support
		# until June 2023.
		GO_ENVS := $(GO_ENVS) CGO_ENABLED=1
	else
		GO_ENVS := $(GO_ENVS) CGO_ENABLED=0
	endif
endif

download:
	$Q go mod download

build: $(PREFIX)bin/$(BINNAME)
	@echo "Build Complete!"

$(PREFIX)bin/$(BINNAME): download $(call rwildcard,*.go)
	$Q mkdir -p $(@D)
	$Q $(GOOS_OVERRIDE) GOFLAGS="$(GOFLAGS)" $(GO_ENVS) go build -v -o $(PREFIX)bin/$(BINNAME) $(LDFLAGS) $(PKG)

# Target to force a build of step-ca without running tests
simple: build

.PHONY: download build simple

#########################################
# Go generate
#########################################

generate:
	$Q go generate ./...

.PHONY: generate

#########################################
# Test
#########################################
test: testdefault testtpmsimulator combinecoverage

testdefault:
	$Q $(GO_ENVS) gotestsum -- -coverprofile=defaultcoverage.out -short -covermode=atomic ./...

testtpmsimulator:
	$Q CGO_ENABLED=1 gotestsum -- -coverprofile=tpmsimulatorcoverage.out -short -covermode=atomic -tags tpmsimulator ./acme 

testcgo:
	$Q gotestsum -- -coverprofile=coverage.out -short -covermode=atomic ./...

combinecoverage:
	cat defaultcoverage.out tpmsimulatorcoverage.out > coverage.out

.PHONY: test testdefault testtpmsimulator testcgo combinecoverage

integrate: integration

integration: bin/$(BINNAME)
	$Q $(GO_ENVS) gotestsum -- -tags=integration ./integration/...

.PHONY: integrate integration

#########################################
# Linting
#########################################

fmt:
	$Q goimports -l -w $(SRC)

lint: SHELL:=/bin/bash
lint:
	$Q LOG_LEVEL=error golangci-lint run --config <(curl -s https://raw.githubusercontent.com/smallstep/workflows/master/.golangci.yml) --timeout=30m
	$Q govulncheck ./...

.PHONY: fmt lint

#########################################
# Install
#########################################

INSTALL_PREFIX?=/usr/local/

install: $(PREFIX)bin/$(BINNAME)
	$Q install -D $(PREFIX)bin/$(BINNAME) $(DESTDIR)$(INSTALL_PREFIX)bin/$(BINNAME)

uninstall:
	$Q rm -f $(DESTDIR)$(INSTALL_PREFIX)/bin/$(BINNAME)

.PHONY: install uninstall

#########################################
# Clean
#########################################

clean:
ifneq ($(BINNAME),"")
	$Q rm -f bin/$(BINNAME)
endif

.PHONY: clean

#########################################
# Dev
#########################################

run:
	$Q go run cmd/step-ca/main.go $(shell step path)/config/ca.json

.PHONY: run

=== debian/changelog ===
golang-github-smallstep-certificates (0.28.4-2) unstable; urgency=medium

  * Ignore failing test for now.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 21 Oct 2025 16:51:34 +0200

golang-github-smallstep-certificates (0.28.4-1) unstable; urgency=medium

  * Use gbp debian-branch debian/latest.
  * New upstream version 0.28.4
  * Standards-Version: 4.7.2.
  * Drop Rules-Requires-Root: no.
  * Use watch v5.
  * Use --no-binaries to avoid scripts/badger-migration.
  * Run wrap-and-sort -atkb.
  * Refresh B-D/D's.
  * Add Salsa CI as debian/salsa-ci.yml.
  * Disable all old patches (not needed?!).
  * Patch to disable use of Nebula (Debian revdep issue).
  * Patch to fix go-attestation namespace.
  * Patch to fix step/cli-utils namespace.
  * Exclude scripts/badger-migration from build.
  * Install authority/provisioner/aws_certificates.pem.
  * Further disabling of Nebula.
  * Disable some failing tests.
  * Fix d/copyright for verify.go (thanks lrc).
  * Bump debian/* copyright years.
  * Fix executable-not-elf-or-script.
  * Silence patch-file-present-but-not-mentioned-in-series.
  * Drop lintian-overrides.
  * Cleanup d/rules formatting.
  * Add myself as Uploaders.
  * Improve d/copyright for test/integration/scep/internal/x509/.
  * Reduce B-D/D's thanks to check-depends.
  * Use dh-sequence-golang.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 16 Oct 2025 10:51:12 +0200

=== debian/control ===
Source: golang-github-smallstep-certificates
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Peymaneh <peymaneh@posteo.net>,
           Simon Josefsson <simon@josefsson.org>,
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-golang,
               golang-any,
               golang-github-ccoveille-go-safecast-dev,
               golang-github-coreos-go-oidc-v3-dev,
               golang-github-fxamacker-cbor-dev,
               golang-github-go-chi-chi-dev,
               golang-github-google-go-attestation-dev,
               golang-github-google-go-tpm-dev,
               golang-github-google-uuid-dev,
               golang-github-masterminds-sprig-dev,
               golang-github-newrelic-go-agent-dev,
               golang-github-pkg-errors-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-rs-xid-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-smallstep-assert-dev <!nocheck>,
               golang-github-smallstep-linkedca-dev,
               golang-github-smallstep-nosql-dev,
               golang-github-smallstep-pkcs7-dev,
               golang-github-smallstep-scep-dev,
               golang-github-stretchr-testify-dev <!nocheck>,
               golang-github-urfave-cli-dev,
               golang-golang-x-crypto-dev (>> 0.39~),
               golang-golang-x-net-dev,
               golang-step-cli-utils-dev,
               libpcsclite-dev,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-smallstep-certificates
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-smallstep-certificates.git
Homepage: https://github.com/smallstep/certificates
XS-Go-Import-Path: github.com/smallstep/certificates

Package: golang-github-smallstep-certificates-dev
Architecture: all
Depends: golang-github-ccoveille-go-safecast-dev,
         golang-github-coreos-go-oidc-v3-dev,
         golang-github-fxamacker-cbor-dev,
         golang-github-go-chi-chi-dev,
         golang-github-google-go-attestation-dev,
         golang-github-google-go-tpm-dev,
         golang-github-google-uuid-dev,
         golang-github-masterminds-sprig-dev,
         golang-github-newrelic-go-agent-dev,
         golang-github-pkg-errors-dev,
         golang-github-prometheus-client-golang-dev,
         golang-github-rs-xid-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-smallstep-linkedca-dev,
         golang-github-smallstep-nosql-dev,
         golang-github-smallstep-pkcs7-dev,
         golang-github-smallstep-scep-dev,
         golang-github-urfave-cli-dev,
         golang-golang-x-crypto-dev (>> 0.39~),
         golang-golang-x-net-dev,
         golang-step-cli-utils-dev,
         libpcsclite-dev,
         ${misc:Depends},
Description: go libraries for private certificate authority
 step-ca is and online certificate authority for secure, automated certificate
 management.
 .
 This package provides multiple go modules used by step-ca (scep, acme, db to
 name a few) as well as example implementations of clients and servers.

=== debian/rules ===
#!/usr/bin/make -f

# Exclude cas/cloudcas, kms/cloudkms and cmd/step-cloudkms-init until
# golang-google-cloud in Debian has been updated to v0.83.0+
export DH_GOLANG_EXCLUDES := \
	cmd \
	cas/cloudcas \
	kms/cloudkms \
	kms/azurekms \
	cas/vaultcas \
	examples \
	scripts/badger-migration \
	# EOF

export DH_GOLANG_INSTALL_EXTRA := authority/provisioner/aws_certificates.pem

%:
	dh $@ --builddirectory=_build --buildsystem=golang

execute_before_dh_auto_configure:
	chmod -v -x policy/engine.go policy/engine_test.go policy/options.go
	rm -fv authority/provisioner/nebula*.go

override_dh_auto_install:
	dh_auto_install -- --no-binaries

# TestCustomTemplateOptions: https://github.com/smallstep/certificates/issues/2441
SKIP_TESTS="Test_newHTTPClient|TestPKI_GenerateConfig|TestDB_GetDpopToken|TestDB_CreateDpopToken|TestDB_GetOidcToken|TestDB_CreateOidcToken|TestCustomTemplateOptions"
override_dh_auto_test:
	dh_auto_test $(DH_BUILD_OPTS) -- -skip $(SKIP_TESTS)
	-timeout 5m dh_auto_test $(DH_BUILD_OPTS) -- -run $(SKIP_TESTS)

## golang-github-smallstep-certificates 0.29.0

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 	$Q curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $$(go env GOPATH)/bin latest
 	$Q go install golang.org/x/vuln/cmd/govulncheck@latest
 	$Q go install gotest.tools/gotestsum@latest
-	$Q go install github.com/goreleaser/goreleaser@latest
+	$Q go install github.com/goreleaser/goreleaser/v2@latest
 	$Q go install github.com/sigstore/cosign/v2/cmd/cosign@latest
 
 .PHONY: bootstra%

=== debian/changelog ===
golang-github-smallstep-certificates (0.29.0-3) unstable; urgency=medium

  * Increase dh_auto_test timeout 10m->30m for riscv64 debci

 -- Simon Josefsson <simon@josefsson.org>  Tue, 17 Feb 2026 22:47:27 +0100

golang-github-smallstep-certificates (0.29.0-2) unstable; urgency=medium

  * Use proper smallstep/cli-utils
  * Drop Priority: optional
  * Standards-Version: 4.7.3
  * Bump debian/* copyright years
  * Use modern Salsa rdep

 -- Simon Josefsson <simon@josefsson.org>  Sun, 08 Feb 2026 12:47:26 +0100

golang-github-smallstep-certificates (0.29.0-1) unstable; urgency=medium

  * Upload to unstable

 -- Simon Josefsson <simon@josefsson.org>  Sun, 07 Dec 2025 21:30:54 +0100

golang-github-smallstep-certificates (0.29.0-1~exp0) experimental; urgency=medium

  * New upstream version 0.29.0
  * Refresh patches
  * Bump B-D on go-safecast to v2
  * Salsa CI fixes
  * Add B-D golang-github-coreos-go-systemd-dev

 -- Simon Josefsson <simon@josefsson.org>  Sun, 07 Dec 2025 17:09:14 +0100

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,12 @@
            Simon Josefsson <simon@josefsson.org>,
 Section: golang
 Testsuite: autopkgtest-pkg-go
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-golang,
                golang-any,
-               golang-github-ccoveille-go-safecast-dev,
+               golang-github-ccoveille-go-safecast-dev (>> 2.0.0~),
                golang-github-coreos-go-oidc-v3-dev,
+               golang-github-coreos-go-systemd-dev,
                golang-github-fxamacker-cbor-dev,
                golang-github-go-chi-chi-dev,
                golang-github-google-go-attestation-dev,
@@ -22,6 +22,7 @@
                golang-github-rs-xid-dev,
                golang-github-sirupsen-logrus-dev,
                golang-github-smallstep-assert-dev <!nocheck>,
+               golang-github-smallstep-cli-utils-dev,
                golang-github-smallstep-linkedca-dev,
                golang-github-smallstep-nosql-dev,
                golang-github-smallstep-pkcs7-dev,
@@ -30,9 +31,8 @@
                golang-github-urfave-cli-dev,
                golang-golang-x-crypto-dev (>> 0.39~),
                golang-golang-x-net-dev,
-               golang-step-cli-utils-dev,
                libpcsclite-dev,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-github-smallstep-certificates
 Vcs-Git: https://salsa.debian.org/go-team/packages/golang-github-smallstep-certificates.git
 Homepage: https://github.com/smallstep/certificates
@@ -40,8 +40,9 @@
 
 Package: golang-github-smallstep-certificates-dev
 Architecture: all
-Depends: golang-github-ccoveille-go-safecast-dev,
+Depends: golang-github-ccoveille-go-safecast-dev (>> 2.0.0~),
          golang-github-coreos-go-oidc-v3-dev,
+         golang-github-coreos-go-systemd-dev,
          golang-github-fxamacker-cbor-dev,
          golang-github-go-chi-chi-dev,
          golang-github-google-go-attestation-dev,
@@ -53,6 +54,7 @@
          golang-github-prometheus-client-golang-dev,
          golang-github-rs-xid-dev,
          golang-github-sirupsen-logrus-dev,
+         golang-github-smallstep-cli-utils-dev,
          golang-github-smallstep-linkedca-dev,
          golang-github-smallstep-nosql-dev,
          golang-github-smallstep-pkcs7-dev,
@@ -60,7 +62,6 @@
          golang-github-urfave-cli-dev,
          golang-golang-x-crypto-dev (>> 0.39~),
          golang-golang-x-net-dev,
-         golang-step-cli-utils-dev,
          libpcsclite-dev,
          ${misc:Depends},
 Description: go libraries for private certificate authority

=== debian/rules ===
--- 
+++ 
@@ -27,5 +27,5 @@
 # TestCustomTemplateOptions: https://github.com/smallstep/certificates/issues/2441
 SKIP_TESTS="Test_newHTTPClient|TestPKI_GenerateConfig|TestDB_GetDpopToken|TestDB_CreateDpopToken|TestDB_GetOidcToken|TestDB_CreateOidcToken|TestCustomTemplateOptions"
 override_dh_auto_test:
-	dh_auto_test $(DH_BUILD_OPTS) -- -skip $(SKIP_TESTS)
+	dh_auto_test $(DH_BUILD_OPTS) -- -timeout 30m -skip $(SKIP_TESTS)
 	-timeout 5m dh_auto_test $(DH_BUILD_OPTS) -- -run $(SKIP_TESTS)
